// -----------------------------------------------------------------
// JavaORB
//
//						Bi-Directional IIOP
//
// (c) Distributed Object Group
// -----------------------------------------------------------------

public class Client
{
	public static void main( String args[] )
	{
		// .1
		// Initialize the ORB
		org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args,null);		

		// 2.
		// Initialize the BOA
		org.omg.CORBA.BOA boa = org.omg.CORBA.BOA.init(orb,args);

		// 3.
		// Instanciate Client object
		ClientObjectImpl clt = new ClientObjectImpl();		
			
		// 4.
		// Connect the instance to BOA
		boa.connect(clt);
		
		// 5.
		// Activate the instance
		boa.obj_is_ready(clt);		
		
		// 6.
		// Create the server activity
		ClientServer cs = new ClientServer( boa );		
		cs.start();
		
		// 7.
		// Get ServerObject reference
		ServerObject serv = null;
		org.omg.CORBA.Object obj = null;
		try
		{			
			java.io.FileInputStream file = new java.io.FileInputStream("ObjectId");
			java.io.DataInputStream myInput = new java.io.DataInputStream(file);
			String stringTarget = myInput.readLine();
			
			obj = orb.string_to_object(stringTarget);

		}
		catch ( java.io.IOException ex )
		{
			System.out.println("File error");
			System.exit(0);
		}

		// 8.
		// Narrow the object reference
		serv = ServerObjectHelper.narrow(obj);		

		// 9.
		// Use the Server Object
		try
		{
			serv.callClient( clt );	
			
			System.out.println("Remote call finished...");
		}
		catch ( org.omg.CORBA.SystemException ex )
		{
			System.out.println("A CORBA System exception has been intercepted");
			System.out.println(ex.getMessage());
		}

	}
}