// -----------------------------------------------------------------------
//
// This is an example that shows how to write an Adapter Activator
//
// (c) Distributed Object Group
// -----------------------------------------------------------------------

public class AdpActivator extends org.omg.PortableServer.AdapterActivatorPOA 
{

	// ---
	//
	// This method is autmatically called by the POA to activate a new POA.
	//
	// ---
  	public boolean unknown_adapter ( org.omg.PortableServer.POA parent, String name) 
  	{
  		System.out.println("I am the AdapterActivator called by POA " + parent.the_name() + " to create " + name );
    
    	// Create the POA
    	org.omg.CORBA.Policy[] policies = new org.omg.CORBA.Policy[1];
    	    	
    	policies[0] = _default_POA().create_lifespan_policy( org.omg.PortableServer.LifespanPolicyValue.PERSISTENT);
    	
    	org.omg.PortableServer.POA childPOA = null;
    	try 
    	{
      		childPOA = parent.create_POA(name, parent.the_POAManager(), policies);
    	} 
    	catch ( java.lang.Exception e) 
    	{
      		e.printStackTrace();
      		return false;
    	}

		// Set the same AdapterActiver ( this )
    	childPOA.the_activator(parent.the_activator());

		// If the POA that has been created if "secondPOA", we must activate its servant.
    	if ( name.equals("secondPOA") ) 
    	{
      		System.out.println("Creates the Servant"); 
     
     		// Create the Servant
      		CalculatriceImpl calc = new CalculatriceImpl();
      		
      		// Activate the Servant 
      
    		byte [] servantId = "myObject".getBytes();
			
			try
			{
				childPOA.activate_object_with_id( servantId, calc );
			}
			catch ( java.lang.Exception ex )
			{
				ex.printStackTrace();
				return false;
			}
      	
    	}
    	
    	return true;
  	}
  
}
