// ===========================================================
// This a simple servant locator implementation
//
// Jerome DANIEL
// ===========================================================

/*-----------------------------------------------------------*\
 *				  	 ServantLocator implementation 		     *
\*-----------------------------------------------------------*/

public class SrvLocator extends org.omg.PortableServer.ServantLocatorPOA
{
	/**
	 * Reference to the servant
	 */
	private org.omg.PortableServer.Servant servant;
									   
	/**
	 * Constructor
	 */
	public SrvLocator() 
	{
		servant = new CalculatriceImpl();
	}
	
	/**
	 * Operation preinvoke
	 * 
	 * This function is called to locate a servant
	 * 
	 * @param	oid			the object id of the waited object
	 * @param	adapter		an object adapter reference
	 * @return	the found servant
	 */
	public org.omg.PortableServer.Servant preinvoke(byte[] oid, org.omg.PortableServer.POA adapter, java.lang.String operation, org.omg.PortableServer.ServantLocatorPackage.CookieHolder the_cookie)
		throws org.omg.PortableServer.ForwardRequest
	{
		String oidStr = new String(oid);
		
		System.out.println("[ Servant Locator ] preinvoke => method : "+ operation +" / oid : "+ oidStr );

		the_cookie.value = oidStr;
		
		return servant;
	}

	/**
	 * Operation postinvoke
	 */
	public void postinvoke(byte[] oid, org.omg.PortableServer.POA adapter, java.lang.String operation, java.lang.Object the_cookie, org.omg.PortableServer.Servant the_servant)
	{
		String oidStr = new String(oid);
		
		System.out.println("[ Servant Locator ] postinvoke => method : "+ operation +" / oid : "+ oidStr);

		if (!oidStr.equals(the_cookie))
			throw new org.omg.CORBA.OBJECT_NOT_EXIST();
	}	

}

