// ---------------------------------------------------------------------------
// JavaORB
//
//		            Message Interceptors Example
//
// (c) Distributed Object Group, 1999
// ---------------------------------------------------------------------------


/**
 * This class implements a message interceptor for JavaORB. A message interceptor must implements
 * the JavaORB interface 'JavaORB.Interceptor.MessageInterceptor'. This interface provides two
 * operations :
 *
 *      - send_message : this operation is called when a message is send
 *	- receive_message : this operation is called when a message is received
 *
 * @author Jerome DANIEL
 */
public class myMessageInterceptor implements JavaORB.Interceptor.MessageInterceptor
{
	/**
	 * Operation send_message
	 */
	public void send_message(org.omg.CORBA.Object target, JavaORB.Interceptor.MessageManager msg)
	{				
		
		if ( target != null )
		{
			// we obtain the message in
			JavaORB.Interceptor.MessageIn msg_in = msg.messageIn();
		
			JavaORB.Interceptor.MessageIn new_msg_in = msg.newMessageIn();
		
			byte [] old_content = msg_in.content(); // Get message in content
		
			// Insert user name
			String user_name = System.getProperty("user.name");
		
			byte [] new_content = new byte[ old_content.length + 4 + user_name.length() ];
		
			new_content[0] = 0;
			new_content[1] = 1;
			new_content[2] = 2;
			new_content[3] = (byte) user_name.length();
		
			byte [] user_name_buffer = user_name.getBytes();
			
			System.arraycopy( user_name_buffer, 0, new_content, 4, user_name_buffer.length );
		
			System.arraycopy( old_content, 0, new_content, 4 + user_name_buffer.length, old_content.length );
		
			new_msg_in.content( new_content );
		}
	}

	/**
	 * Operation receive_message
	 */
	public boolean receive_message(org.omg.CORBA.Object target, JavaORB.Interceptor.MessageManager msg)
	{				
		JavaORB.Interceptor.MessageOut msg_out = msg.messageOut();
		
		// Check the header
		byte [] content = msg_out.content();
		
		if ( content.length > 0 )		
		if ( ( content[0] == 0 ) && ( content[1] == 1 ) && ( content[2] == 2 ) )
		{
			int size = ( int ) content[3];
				
			byte [] name = new byte[ size ];
			
			if ( size + 4 <= msg_out.size() )
			{
				msg.getMessageOut( name, 4, 0, size );
				
				msg_out.consume( size + 4 );
			}
			else
			{
				msg.getMessageOut( name, 4, 0, msg_out.size() - 4 );
				
				int index = 4 + msg_out.size();
				
				size = size - ( msg_out.size() - 4 );
				
				msg_out.consumeAll();
				
				msg.getMessageOut( name, index, 0, size );
				
				msg_out = msg.messageOut();
				
				msg_out.consumeAll();
			}
			
			String name_str = new String( name );
			
			System.out.println("This call emitter is " + name_str );									
		}
		
		return false;
	}
}