/**
 * This class is an example of IOR managment with JavaORB facilities.
 * 
 * @author	Jerome DANIEL	
 * @version	1.0
 */
public class iordump
{
	/**
	 * Entry point
	 */
	public static void main( String [] args )
	{
		System.out.println("IOR dump");
		System.out.println("");
		
		org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init( args, null );
		
		if ( args.length == 0 )
		{
			System.out.println("Please give as argument the IOR file name.");
			System.exit(0);
		}
		
		String file_name = args[0];
		
		org.omg.CORBA.Object obj = null;

		try
		{			
			java.io.FileInputStream file = new java.io.FileInputStream(file_name);
			java.io.DataInputStream myInput = new java.io.DataInputStream(file);
			java.io.InputStreamReader reader = new java.io.InputStreamReader( myInput );
			java.io.BufferedReader buffer = new java.io.BufferedReader( reader );
			String stringTarget = buffer.readLine();
		
			obj = orb.string_to_object(stringTarget);
		}
		catch ( java.io.IOException e )
		{
			System.out.println("IOR file not found : " + file_name);
			System.exit(0);
		}	
		
		dump( obj );
	}
	
	/**
	 * This function dumps an IOR
	 */
	public static void dump( org.omg.CORBA.Object obj )
	{
		JavaORB.util.IORManager ior_manager = new JavaORB.util.IORManager();
		
		JavaORB.util.IORBag ior_bag = null;
		
		ior_bag = ior_manager.extract( obj );
		
		System.out.println("");
		System.out.println("IOR dump result");
		System.out.println("");
		System.out.println("IIOP version : " + ior_bag.version.major + "." + ior_bag.version.minor );
		System.out.println("Host name : " + ior_bag.host );
		System.out.println("Port number : " + ior_bag.port );
		System.out.println("Object id : " + ior_bag.id );
		System.out.println("Object key : " + new String( ior_bag.key ) );
		System.out.println("");
	}
}