/**
 * This class is a client for the example of local invocation for POA
 * 
 * @author	Jerome DANIEL
 * @version	1.0
 */
public class Client
{
	public static void main( String args[] )
	{		
		// 1.
		// Initialize the ORB
		org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args,null);

		// 2.
		// Get the Calculator reference from a file
		localFactory factory = null;
		org.omg.CORBA.Object obj = null;
		try
		{			
			java.io.FileInputStream file = new java.io.FileInputStream("ObjectId");
			java.io.DataInputStream myInput = new java.io.DataInputStream(file);
			String stringTarget = myInput.readLine();
			
			obj = orb.string_to_object(stringTarget);

		}
		catch ( java.io.IOException ex )
		{
			System.out.println("File error");
			System.exit(0);
		}

		// 3.
		// Narrow the object reference
		factory = localFactoryHelper.narrow(obj);		

		// 4.
		// Use the object
		try
		{
			factory.doLocalInvocation();
		}		
		catch ( org.omg.CORBA.SystemException ex )
		{
			System.out.println("A CORBA System exception has been intercepted");
			System.out.println(ex.getMessage());
		}

	}
}