/**
 * This class is an example of threads policies under JavaORB.
 * 
 * @author	Jerome DANIEL
 * @version	1.0
 */
public class Client
{
	
	/**
	 * Entry point
	 */
	public static void main( String [] args )
	{		
		// Check for arguments
		if ( args.length == 0 )
		{
			System.out.println("Please pass as argument the test type");
			System.out.println("");
			System.out.println("count ........... for count operation");
			System.out.println("inc .......... for inc operation");			
			System.out.println("");
			System.exit(0);
		}
		
		// 1.
		// Initialise the ORB
		org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init( args, null );		

		// 2.
		// Import remote object reference
		counter c = null;
		org.omg.CORBA.Object obj = null;
		try
		{			
			java.io.FileInputStream file = new java.io.FileInputStream("ObjectId");
			java.io.DataInputStream myInput = new java.io.DataInputStream(file);
			java.io.InputStreamReader reader = new java.io.InputStreamReader( myInput );
			java.io.BufferedReader rInput = new java.io.BufferedReader( reader );
			String stringTarget = rInput.readLine();
			
			obj = orb.string_to_object(stringTarget);

		}
		catch ( java.io.IOException ex )
		{
			System.out.println("File error");
			System.exit(0);
		}

		// 3.
		// Narrow the object reference
		c = counterHelper.narrow(obj);
		
		// 4.
		// Now use the remote object
		try
		{
			while ( true )
			{
				if ( args[0].equals("count") )
					System.out.println("My counter is : " + c.count() );
				else
				if ( args[0].equals("inc") )
				{
					System.out.println("I increment the counter");
					c.inc();
				}
				else
				{
					System.out.println("Unknown test type : " + args[0] );
					break;
				}
			}
		}
		catch ( org.omg.CORBA.SystemException ex )
		{
			System.out.println("A system exception has been intercepted...");
			System.out.println( ex.getMessage() );
		}
		
	}
			
}