// ============================================================
// = CORBA Sample				                              =
// ============================================================

// Server with BOA

public class Server
{
	public static void main( String args[] )
	{
		// .1
		// Initialize the ORB
		org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args,null);		

		// 2.
		// Initialize the BOA
		org.omg.CORBA.BOA boa = org.omg.CORBA.BOA.init(orb,args);

		// 3.
		// Instanciate Calculator object
		CalculatorImpl calc = new CalculatorImpl();		
			
		// 4.
		// Connect the instance to BOA
		boa.connect(calc);
		
		// 5.
		// Activate the instance
		boa.obj_is_ready(calc);		
		
		// 6.
		// Export into a file the object reference
		String reference = orb.object_to_string(calc);
		try
		{
			java.io.FileOutputStream file = new java.io.FileOutputStream("ObjectId");
			java.io.PrintStream pfile=new java.io.PrintStream(file);
			pfile.println(reference);
		}
		catch ( java.io.IOException ex )
		{
			System.out.println("File error");
		}

		// 7.
		// Wait for invocations
		try
		{
			System.out.println("The server is ready...");
			boa.impl_is_ready();
		}
		catch ( java.lang.Exception ex )
		{
			System.out.println("An exception has been intercepted.");
		}

	}
}