// ============================================================
// = CORBA Sample				                              =
// ============================================================


public class Client
{
	public static void main( String args[] )
	{
		org.omg.CORBA.Object obj = null;
		Calculator calc = null;
		
		// 1.
		// Initialize the ORB
		org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args,null);		
		
		// 2. 
		// Invoke the loader to get the Calculator object reference		
		obj = JavaORB.util.Loader.bind("Calculator");

		// 3.
		// Narrow the object reference to Calculator reference
		calc = CalculatorHelper.narrow(obj);		

		// 4.
		// Use the calculator object
		try
		{
			System.out.println("5 + 3 = " + calc.add(5,3) );

			System.out.println("5 / 0 = " + calc.div(5,0) );
		}
		catch ( DivisionByZero ex )
		{
			System.out.println("A division by zero has been intercepted");
			System.out.println("The division was "+ex.op1+" / "+ex.op2);
		}
		catch ( org.omg.CORBA.SystemException ex )
		{
			System.out.println("A CORBA system exception has been intercepted");
			System.out.println(ex.getMessage());
		}

	}
}